Use jessie as new default release
[grml-debootstrap.git] / chroot-script
1 #!/bin/sh
2 # Filename:      /etc/debootstrap/chroot-script
3 # Purpose:       script executed in chroot when installing Debian via grml-debootstrap
4 # Authors:       grml-team (grml.org), (c) Michael Prokop <mika@grml.org>
5 # Bug-Reports:   see http://grml.org/bugs/
6 # License:       This file is licensed under the GPL v2.
7 ################################################################################
8 # GRML_CHROOT_SCRIPT_MARKER - do not remove this line unless you want to keep
9 # this script as /bin/chroot-script on your new installed system
10 ################################################################################
11
12 . /etc/debootstrap/config    || exit 1
13 . /etc/debootstrap/variables || exit 1
14
15 [ -r /proc/1 ] || mount -t proc none /proc
16
17 # variable checks {{{
18
19 # use aptitude only if it's available
20 if [ -x /usr/bin/aptitude ] ; then
21    APTUPDATE="aptitude update $DPKG_OPTIONS"
22    # Debian ISOs do not contain signed Release files
23    if [ -n "$ISO" ] ; then
24       APTINSTALL="aptitude -y --allow-untrusted --without-recommends install $DPKG_OPTIONS"
25       APTUPGRADE="aptitude -y --allow-untrusted safe-upgrade $DPKG_OPTIONS"
26    else
27       APTINSTALL="aptitude -y --without-recommends install $DPKG_OPTIONS"
28       APTUPGRADE="aptitude -y safe-upgrade $DPKG_OPTIONS"
29    fi
30 else
31    APTINSTALL="apt-get --force-yes -y --no-install-recommends install $DPKG_OPTIONS"
32    APTUPDATE="apt-get update $DPKG_OPTIONS"
33    APTUPGRADE="apt-get --force-yes -y upgrade $DPKG_OPTIONS"
34 fi
35
36 if [ -z "$STAGES" ] ; then
37    STAGES='/etc/debootstrap/stages'
38    [ -d "$STAGES" ] || mkdir -p "$STAGES"
39 fi
40 # }}}
41
42 # helper functions {{{
43 stage() {
44   if [ -n "$2" ] ; then
45      echo "$2" > "$STAGES/$1"
46      return 0
47   elif grep -q done "$STAGES/$1" 2>/dev/null ; then
48      echo "   [*] Notice: stage $1 has been executed already, skipping execution therefore.">&2
49      return 1
50   fi
51   echo "   Executing stage ${1}"
52   return 0
53 }
54
55 askpass() {
56   # read -s emulation for dash. result is in $resp.
57   set -o noglob
58   [ -t 0 ] && stty -echo
59   read resp
60   [ -t 0 ] && stty echo
61   set +o noglob
62 }
63 # }}}
64
65 # define chroot mirror {{{
66 chrootmirror() {
67   if [ -n "$KEEP_SRC_LIST" ] ; then
68     echo "KEEP_SRC_LIST has been set, skipping chrootmirror stage."
69     return
70   fi
71
72   if [ -z "$COMPONENTS" ] ; then
73     COMPONENTS='main contrib non-free'
74   fi
75   echo "Using repository components $COMPONENTS"
76
77   if [ -n "$ISO" ] ; then
78     echo "Adjusting sources.list for ISO (${ISO})."
79     echo "deb $ISO $RELEASE $COMPONENTS" > /etc/apt/sources.list
80     echo "Adding mirror entry (${MIRROR}) to sources.list."
81     [ -n "$MIRROR" ] && echo "deb $MIRROR $RELEASE $COMPONENTS" >> /etc/apt/sources.list || true
82   else
83     if [ -n "$MIRROR" ] ; then
84       echo "Adjusting sources.list for mirror (${MIRROR})."
85       echo "deb $MIRROR $RELEASE $COMPONENTS" > /etc/apt/sources.list
86     fi
87   fi
88
89   # add security.debian.org:
90   case "$RELEASE" in
91     unstable|sid|lenny) ;;  # no security pool available
92     *)
93       echo "Adding security.debian.org to sources.list."
94       echo "deb http://security.debian.org ${RELEASE}/updates $COMPONENTS" >> /etc/apt/sources.list
95       ;;
96   esac
97 }
98 # }}}
99
100 # remove local chroot mirror {{{
101 remove_chrootmirror() {
102   if [ -n "$KEEP_SRC_LIST" ] ; then
103     echo "KEEP_SRC_LIST has been set, skipping remove_chrootmirror stage."
104     return
105   fi
106
107   if [ -n "$ISO" ] ; then
108     echo "Removing ISO (${ISO}) from sources.list."
109     TMP_ISO=$(echo "$ISO" |sed 's#/#\\/#g')
110     sed -i "/deb $TMP_ISO $RELEASE $COMPONENTS/ D" /etc/apt/sources.list
111   else
112     if [ -n "$MIRROR" -a -n "$(echo $MIRROR|grep file:)" ] ; then
113       echo "Removing local mirror (${MIRROR}) from sources.list."
114       TMP_MIRROR=$(echo "$MIRROR" |sed 's#/#\\/#g')
115       sed -i "/deb $TMP_MIRROR $RELEASE $COMPONENTS/ D" /etc/apt/sources.list
116       echo "Adding fallback mirror entry (${FALLBACK_MIRROR}) to sources.list instead."
117       echo "deb $FALLBACK_MIRROR $RELEASE $COMPONENTS" >> /etc/apt/sources.list
118     fi
119   fi
120 }
121 # }}}
122
123 # set up grml repository {{{
124 grmlrepos() {
125   if [ -n "$GRMLREPOS" ] ; then
126      # user might have provided their own apt sources.list
127      if ! grep -q grml /etc/apt/sources.list.d/grml.list 2>/dev/null ; then
128         cat >> /etc/apt/sources.list.d/grml.list << EOF
129 # grml: stable repository:
130   deb     http://deb.grml.org/ grml-stable  main
131   deb-src http://deb.grml.org/ grml-stable  main
132
133 # grml: testing/development repository:
134   deb     http://deb.grml.org/ grml-testing main
135   deb-src http://deb.grml.org/ grml-testing main
136 EOF
137      fi
138
139      if apt-get update $DPKG_OPTIONS; then
140        apt-get -y --allow-unauthenticated install grml-debian-keyring $DPKG_OPTIONS
141        apt-get update $DPKG_OPTIONS
142      else
143        # make sure we have the keys available for aptitude
144        gpg --keyserver subkeys.pgp.net --recv-keys F61E2E7CECDEA787
145        gpg --export F61E2E7CECDEA787 | apt-key add - || true # not yet sure
146        # why it's necessary, sometimes we get an error even though it works [mika]
147      fi
148
149      # make sure we install packages from Grml's pool only if not available
150      # from Debian!
151      if ! grep -q grml /etc/apt/preferences 2>/dev/null ; then
152         cat >> /etc/apt/preferences << EOF
153 // debian pool (default):
154 Package: *
155 Pin: release o=Debian
156 Pin-Priority: 996
157
158 // main grml-repository:
159 Package: *
160 Pin: origin deb.grml.org
161 Pin-Priority: 991
162 EOF
163      fi
164   fi
165 }
166 # }}}
167
168 # check available backports release version {{{
169 checkbackports() {
170   wget -q -O/dev/null http://backports.debian.org/debian-backports/dists/${1}-backports/Release
171 }
172 # }}}
173
174 # feature to provide Debian backports repos {{{
175 backportrepos() {
176     if [ -n "$BACKPORTREPOS" ] ; then
177         if ! checkbackports $RELEASE ; then
178             echo "Backports for ${RELEASE} are not available." >&2
179             exit 1
180         else
181             # user might have provided their own apt sources.list
182             if ! grep -q backports /etc/apt/sources.list.d/backports.list 2>/dev/null ; then
183                 cat >> /etc/apt/sources.list.d/backports.list << EOF
184 # debian backports: ${RELEASE}-backports repository:
185 deb     http://backports.debian.org/debian-backports ${RELEASE}-backports main
186 deb-src http://backports.debian.org/debian-backports ${RELEASE}-backports main
187 EOF
188             fi
189         fi
190     fi
191 }
192 # }}}
193
194 # set up kernel-img.conf {{{
195 kernelimg_conf() {
196   if ! [ -r /etc/kernel-img.conf ] ; then
197      echo "Setting up /etc/kernel-img.conf"
198      cat > /etc/kernel-img.conf << EOF
199 # Kernel Image management overrides
200 # See kernel-img.conf(5) for details
201 do_initrd = Yes
202 do_symlinks = Yes
203 EOF
204   fi
205 }
206 # }}}
207
208 # make sure services do not start up {{{
209 install_policy_rcd() {
210   if ! [ -r /usr/sbin/policy-rc.d ] ; then
211      export POLICYRCD=1
212      cat > /usr/sbin/policy-rc.d << EOF
213 #!/bin/sh
214 exit 101
215 EOF
216      chmod 775 /usr/sbin/policy-rc.d
217   fi
218 }
219 # }}}
220
221 # make sure we have an up2date system {{{
222 upgrade_system() {
223   if [ "$UPGRADE_SYSTEM" = "yes" ] ; then
224     echo "Running update + upgrade"
225     $APTUPDATE
226     DEBIAN_FRONTEND=$DEBIAN_FRONTEND $APTUPGRADE
227   else
228     echo "Not running update + upgrade as \$UPDATE_AND_UPGRADE is not set to 'yes'."
229   fi
230 }
231
232 # }}}
233 # remove now useless apt cache {{{
234 remove_apt_cache() {
235   if [ "$RM_APTCACHE" = 'yes' ] ; then
236     echo "Cleaning apt cache."
237     apt-get clean $DPKG_OPTIONS
238   else
239     echo "Not cleaning apt cache as \$RM_APTCACHE is unset."
240   fi
241 }
242 # }}}
243
244 # install additional packages {{{
245 packages() {
246   # Pre-seed the debconf database with answers. Each question will be marked
247   # as seen to prevent debconf from asking the question interactively.
248   [ -f /etc/debootstrap/debconf-selections ] && {
249     echo "Preseeding the debconf database, some lines might be skipped..."
250     cat /etc/debootstrap/debconf-selections | debconf-set-selections
251   }
252
253   if [ "$PACKAGES" = 'yes' ] ; then
254      if ! [ -r /etc/debootstrap/packages ] ; then
255        echo "Error: /etc/debootstrap/packages (inside chroot) not found, exiting." >&2
256        exit 1
257      else
258        $APTUPDATE
259        DEBIAN_FRONTEND=$DEBIAN_FRONTEND $APTINSTALL $(grep -v '^#' /etc/debootstrap/packages) $GRMLPACKAGES
260      fi
261   fi
262 }
263 # }}}
264
265 # install extra packages {{{
266 extrapackages() {
267     if [ "$EXTRAPACKAGES" = 'yes' ] ; then
268         PACKAGELIST=$(find /etc/debootstrap/extrapackages -type f -name '*.deb')
269         if [ -n "$PACKAGELIST" ]; then
270             dpkg -i $PACKAGELIST
271             # run apt again to resolve any deps
272             DEBIAN_FRONTEND=$DEBIAN_FRONTEND $APTINSTALL
273         fi
274     fi
275 }
276 # }}}
277
278 # check if the specified Debian package exists
279 package_exists() {
280   output=$(apt-cache show "$1" 2>/dev/null)
281   [ -n "$output" ]
282   return $?
283 }
284
285
286 # determine the kernel version postfix
287 get_kernel_version() {
288   # do not override $KERNEL if set via config file
289   if [ -n "$KERNEL" ] ; then
290     echo "$KERNEL"
291     return 0
292   fi
293
294   case $ARCH in
295     i386)   KARCH=686   ;;
296     amd64)  KARCH=amd64 ;;
297     *)
298       echo "Only i386 and amd64 are currently supported" >&2
299       return 1
300   esac
301
302   for KPREFIX in "" "2.6-" ; do  # iterate through the kernel prefixes,
303                                  # currently "" and "2.6-"
304     if package_exists linux-image-${KPREFIX}${KARCH} ; then
305       echo ${KPREFIX}${KARCH}
306       return 0
307     fi
308
309   done
310 }
311
312 # install kernel packages {{{
313 kernel() {
314   if [ -n "$NOKERNEL" ] ; then
315     echo "Skipping installation of kernel packages as requested via --nokernel"
316     return 0
317   fi
318
319   $APTUPDATE
320   KVER=$(get_kernel_version)
321   if [ -n "$KVER" ] ; then
322      # note: install busybox to be able to debug initramfs
323      KERNELPACKAGES="linux-image-$KVER linux-headers-$KVER busybox firmware-linux-free firmware-linux"
324      DEBIAN_FRONTEND=$DEBIAN_FRONTEND $APTINSTALL $KERNELPACKAGES
325   else
326      echo "Warning: Could not find a kernel for your system. Your system won't be able to boot itself!"
327   fi
328 }
329 # }}}
330
331 # reconfigure packages {{{
332 reconfigure() {
333   if [ -n "$RECONFIGURE" ] ; then
334      for package in $RECONFIGURE ; do
335          if dpkg --list $package >/dev/null 2>&1 | grep -q '^ii' ; then
336            DEBIAN_FRONTEND=$DEBIAN_FRONTEND dpkg-reconfigure $package || \
337            echo "Warning: $package does not exist, can not reconfigure it."
338          fi
339      done
340   fi
341 }
342 # }}}
343
344 # set password of user root {{{
345 passwords()
346 {
347   if [ -n "$NOPASSWORD" ] ; then
348     echo "Skip setting root password as requested."
349     return 0
350   fi
351
352   echo "Activating shadow passwords."
353   shadowconfig on
354
355   CHPASSWD_OPTION=
356   if chpasswd --help 2>&1 | grep -q -- '-m,' ; then
357      CHPASSWD_OPTION='-m'
358   fi
359
360   if [ -n "$ROOTPASSWORD" ] ; then
361      echo root:"$ROOTPASSWORD" | chpasswd $CHPASSWD_OPTION
362      export ROOTPASSWORD=''
363   else
364     a='1'
365     b='2'
366      echo "Setting password for user root:"
367      while [ "$a" != "$b" ] ; do
368        echo -n "Enter new UNIX password for user root: "
369        askpass
370        a="$resp"
371        unset resp
372        echo
373        echo -n "Retype new UNIX password for user root: "
374        askpass
375        b="$resp"
376        unset resp
377        echo
378        if [ "$a" != "$b" ] ; then
379          echo "Sorry, passwords do not match. Retry."
380          a='1'
381          b='2'
382        else
383          echo root:"$a" | chpasswd $CHPASSWD_OPTION
384          unset a
385          unset b
386        fi
387      done
388   fi
389 }
390 # }}}
391
392 # set up /etc/hosts {{{
393 hosts() {
394   if [ -f /etc/hosts ] ; then
395      sed -i "s#127.0.0.1 .*#127.0.0.1       localhost  $HOSTNAME#" /etc/hosts
396      [ -n "$HOSTNAME" ] && sed -i "s/grml/$HOSTNAME/g" /etc/hosts
397   else
398      cat > /etc/hosts << EOF
399 127.0.0.1       localhost $HOSTNAME
400
401 #127.0.0.1       localhost
402 #127.0.1.1       $HOSTNAME.example.org $HOSTNAME
403
404 # The following lines are desirable for IPv6 capable hosts
405 #::1     ip6-localhost ip6-loopback $HOSTNAME
406 ::1     ip6-localhost ip6-loopback
407 fe00::0 ip6-localnet
408 ff00::0 ip6-mcastprefix
409 ff02::1 ip6-allnodes
410 ff02::2 ip6-allrouters
411 ff02::3 ip6-allhosts
412 EOF
413   fi
414 }
415 # }}}
416
417 # set default locales {{{
418 default_locales() {
419   if [ -n "$DEFAULT_LOCALES" ] ; then
420     if ! [ -x /usr/sbin/update-locale ] ; then
421       echo "Warning: update-locale executable not available (no locales package installed?)"
422       echo "Ignoring request to run update-locale for $DEFAULT_LOCALES therefore"
423       return 0
424     fi
425
426     /usr/sbin/update-locale LANGUAGE="$DEFAULT_LANGUAGE" LANG="$DEFAULT_LOCALES"
427   fi
428 }
429 # }}}
430
431 # adjust timezone {{{
432 timezone() {
433   if [ -n "$TIMEZONE" ] ; then
434      echo "Adjusting /etc/localtime"
435      ln -sf /usr/share/zoneinfo/$TIMEZONE /etc/localtime
436   fi
437 }
438 # }}}
439
440 # helper function for fstab() {{{
441 createfstab(){
442      echo "Setting up /etc/fstab"
443 if [ -n "$TARGET_UUID" ] ; then
444    echo "/dev/disk/by-uuid/${TARGET_UUID} /  auto    defaults,errors=remount-ro 0   1" > /etc/fstab
445 else
446    echo "${TARGET} /  auto    defaults,errors=remount-ro 0   1" > /etc/fstab
447 fi
448
449 cat >> /etc/fstab << EOF
450 proc           /proc        proc    defaults                      0   0
451 /dev/cdrom     /mnt/cdrom0  iso9660 ro,user,noauto                0   0
452 # some other examples:
453 # /dev/sda2       none         swap    sw,pri=0             0   0
454 # /dev/hda1       /Grml        ext3    dev,suid,user,noauto 0  2
455 # //1.2.3.4/pub   /smb/pub     cifs    user,noauto,uid=grml,gid=grml 0 0
456 # linux:/pub      /beer        nfs     defaults             0  0
457 # tmpfs           /tmp         tmpfs   size=300M            0  0
458 # /dev/sda5       none         swap    sw                   0  0
459 EOF
460 }
461 # }}}
462
463 # generate /etc/fstab {{{
464 fstab() {
465   # set up /etc/fstab if file is not present (cdebootstrap)
466   if [ ! -f /etc/fstab  ] ; then
467      createfstab
468   fi
469
470   # set up /etc/fstab if file is UNCONFIGURED (debootstrap)
471   if grep -q UNCONFIGURED /etc/fstab ; then
472      createfstab
473   fi
474 }
475 # }}}
476
477 # set up hostname {{{
478 hostname() {
479   if [ -n "$HOSTNAME" ] ; then
480      echo "Setting hostname to ${HOSTNAME}."
481      echo "$HOSTNAME" > /etc/hostname
482
483      # adjust postfix configuration
484      if [ -r /etc/postfix/main.cf ] ; then
485         # adjust hostname related options:
486         sed -i "s/grml/$HOSTNAME/g" /etc/postfix/main.cf
487
488         # listen on loopback interface only:
489         sed -i "s/^inet_interfaces = .*/inet_interfaces = loopback-only/" /etc/postfix/main.cf
490         grep -q inet_interfaces /etc/postfix/main.cf || echo 'inet_interfaces = loopback-only' >> /etc/postfix/main.cf
491      fi
492      if [ -r /etc/mailname ] ; then
493         # adjust /etc/mailname
494         local etc_mail_domain=$(/bin/dnsdomainname 2>/dev/null || echo localdomain)
495         case "$HOSTNAME" in
496           *.*)
497             local mailname="$HOSTNAME"
498             ;;
499           *)
500             local mailname="${HOSTNAME}.${etc_mail_domain}"
501             ;;
502         esac
503         echo "Setting mailname to ${mailname}"
504         echo "$mailname" > /etc/mailname
505      fi
506   fi
507 }
508 # }}}
509
510 # generate initrd/initramfs {{{
511 initrd() {
512   # assume the first available kernel as our main kernel
513   KERNELIMG=$(ls -1 /boot/vmlinuz-* 2>/dev/null | head -1)
514   if [ -z "$KERNELIMG" ] ; then
515      echo 'No kernel image found, skipping initrd stuff.'>&2
516      return
517   fi
518
519   KERNELVER=${KERNELIMG#/boot/vmlinuz-}
520
521   # generate initrd
522   if [ -n "$INITRD" ] ; then
523      echo "Generating initrd."
524      update-initramfs -c -t -k $KERNELVER
525   fi
526 }
527 # }}}
528
529 # grub configuration/installation {{{
530 grub_install() {
531
532   if [ -z "$GRUB" ] ; then
533     echo "Notice: \$GRUB not defined, will not install grub inside chroot at this stage."
534     return 0
535   fi
536
537   if ! dpkg --list grub-pc 2>/dev/null | grep -q '^ii' ; then
538     echo "Notice: grub option set but no grub-pc package, installing it therefore."
539     DEBIAN_FRONTEND=$DEBIAN_FRONTEND $APTINSTALL grub-pc
540   fi
541
542   if ! [ -x "$(which grub-install)" ] ; then
543      echo "Error: grub-install not available. (Error while installing grub package?)" >&2
544      return 1
545   fi
546
547   if [ -n "$SELECTED_PARTITIONS" ] ; then # using sw-raid
548      for device in $SELECTED_PARTITIONS ; do
549         GRUB="${device%%[0-9]}"
550         echo "Installing grub on ${GRUB}:"
551         grub-install --no-floppy "$GRUB"
552      done
553   else
554      echo "Installing grub on ${GRUB}:"
555      grub-install --no-floppy "$GRUB"
556   fi
557
558   echo "Adjusting grub configuration for use on ${GRUB}."
559
560   # finally install grub
561   if [ -x /usr/sbin/update-grub ] ; then
562      UPDATEGRUB='/usr/sbin/update-grub'
563   elif [ -x /sbin/update-grub ] ; then
564      UPDATEGRUB='/sbin/update-grub'
565   else
566     echo "Error: update-grub not available, can not execute it." >&2
567     return 1
568   fi
569
570   $UPDATEGRUB
571 }
572 # }}}
573
574 # execute all scripts present in /etc/debootstrap/chroot-scripts/ {{{
575 custom_scripts() {
576   [ -d /etc/debootstrap/chroot-scripts/ ] || return 0
577
578   for script in /etc/debootstrap/chroot-scripts/* ; do
579       echo "Executing script $script"
580       $script && echo "done" || echo "failed"
581   done
582 }
583 # }}}
584
585 # make sure we don't have any running processes left {{{
586 services() {
587   for service in ssh mdadm mdadm-raid ; do
588     if [ -x /etc/init.d/"$service" ] ; then
589        /etc/init.d/"$service" stop || true
590     fi
591   done
592 }
593 # }}}
594
595 # unmount /proc and make sure nothing is left {{{
596 finalize() {
597   # make sure we don't leave any sensible data
598   rm -f /etc/debootstrap/variables
599
600   [ -n "$POLICYRCD" ] && rm -f /usr/sbin/policy-rc.d
601
602   umount /proc >/dev/null 2>/dev/null || true
603 }
604 # }}}
605
606 # signal handler {{{
607 signal_handler() {
608   finalize
609   [ -n "$1" ] && EXIT="$1" || EXIT="1"
610   exit "$EXIT"
611 }
612 # }}}
613
614 # set signal handler {{{
615 trap signal_handler HUP INT QUIT TERM
616 # }}}
617
618 # execute the functions {{{
619
620  # always execute install_policy_rcd
621  install_policy_rcd
622
623  for i in chrootmirror grmlrepos backportrepos kernelimg_conf \
624      kernel packages extrapackages reconfigure hosts \
625      default_locales timezone fstab hostname initrd grub_install passwords \
626      custom_scripts upgrade_system remove_apt_cache services \
627      remove_chrootmirror; do
628      if stage $i ; then
629        $i && stage $i done || exit 1
630      fi
631   done
632   # always execute the finalize stage:
633   finalize
634 # }}}
635
636 # finally exit the chroot {{{
637   echo "Finished chroot installation, exiting."
638   exit 0
639 # }}}
640
641 ## END OF FILE #################################################################
642 # vim: ai tw=80 expandtab foldmethod=marker